MODULE Matrix;

IMPORT WriteInt, WriteLn, WriteSp;

TYPE  Matrix3x3	= ARRAY [0..2],[0..2] OF INTEGER;

VAR 	X, Y, Z	: Matrix3x3;
	I,J,K	: INTEGER;


PROCEDURE Fibo(A:INTEGER):INTEGER;
VAR 	X,Y,Z   : INTEGER;
BEGIN
        IF A=1 THEN
            RETURN A;
        END;
        IF A=0 THEN
            RETURN A;
        ELSE
            X:=Fibo(A-1);
            Y:=Fibo(A-2);
            Z:=X+Y;
            RETURN Z;
        END;
END Fibo;

PROCEDURE Square(A:INTEGER):INTEGER;
VAR X	:INTEGER;
BEGIN
	X:=A*A;
	RETURN X;	

END Sqaure;

BEGIN
	(*Initialize*)
	FOR I:= 0 TO 2 DO
	    FOR J:= 0 TO 2 DO
		X[I,J]:=Square( 3 + Fibo(I+J));
	    END;
	END;
	
	FOR I:= 0 TO 2 DO
	    FOR J:= 0 TO 2 DO
		Y[I,J]:=I-J;
	    END;
	END;

	
	(*Print*)
	FOR I:= 0 TO 2 DO
	    FOR J:= 0 TO 2 DO
		WriteInt(X[I,J]);
		WriteSp;
		WriteSp;
	    END;
	    WriteLn;
	END;
	WriteLn;
	WriteLn;
	FOR I:= 0 TO 2 DO
	    FOR J:= 0 TO 2 DO
		WriteInt(Y[I,J]);
		WriteSp;
		WriteSp;
	    END;
	    WriteLn;
	END;
	
	
	WriteLn;
	WriteLn;
	(*Multiply*)
	
	FOR I:= 0 TO 2 DO
	    FOR J:= 0 TO 2 DO
		Z[I,J]:=0;
		FOR K:=0 TO 2 DO
		    Z[I,J]:=Z[I,J]+X[I,K]*Y[K,J];
		END;
	    END;
	END;
	
	(*Print Result*)
	FOR I:= 0 TO 2 DO
	    FOR J:= 0 TO 2 DO
		WriteInt(Z[I,J]);
		WriteSp;
		WriteSp;
	    END;
	    WriteLn;
	END;

	WriteLn;
END Matrix.
